$! File MAKEDEMOS.COM; TRANSIENT V3.0; 28 April 2005
$! Copyright (C) 2000-01 Miroslav Kolar
$!
$! VMS DCL procedure to create the standard set (disregarding the current
$! state of the defs.h file) of TRANSIENT demonstration programs (VMS
$! images) in the [.demo.bin] directory, and a command procedure containing
$! the DCL foreign command definitions for the created images.
$!
$! To run this procedure, type @MAKEDEMO
$!
$! Tested with: DEC C V5.7 on OpenVMS Alpha
$!
$ COMPILER = "CC/NAMES=AS_IS/OPTIMIZE/DECC/PREFIX_LIBRARY_ENTRIES=ALL_ENTRIES"
$!
$! If there are problems, try something like /STANDARD=VAXC or /STANDARD=COMMON
$! instead of /DECC/PREFIX_LIBRARY_ENTRIES=ALL_ENTRIES used above.
$! If you don't like the timezone field in time stamps in the TRANSIENT
$! generated files, add NO_TIME_ZONE to the DEFINEs below.
$!
$ SET NOON
$ ON SEVERE_ERROR then GOTO Clean
$ ON CONTROL_Y then GOTO Clean
$!
$ TDIR = F$DIRECTORY()
$ IF F$SEARCH("[.demo]bin.dir") .EQS. "" THEN CREATE/DIRECTORY [.demo.bin]
$!
$ WRITE SYS$OUTPUT "Making TRANSIENT objects ..."
$ 'COMPILER' /DEFINE=("PDMtrace=0") -
 transien.c,InOut.c,nl3bandv.c,nl3band1.c, -
 lufacv.c,dynarr.c,matrixv.c,matinvv.c,signals.c,DateTime.c 
$ PURGE *.obj
$!
$ OBJECTS = "[-.-]transien.obj+[-.-]InOut.obj+[-.-]dynarr.obj+[-.-]signals.obj+[-.-]DateTime.obj"
$ OBJECTS1 = OBJECTS + "+[-.-]nl3band1.obj"
$ OBJECTSv = OBJECTS + "+[-.-]nl3bandv.obj+[-.-]lufacv.obj+[-.-]matrixv.obj+[-.-]matinvv.obj"
$!
$ WRITE SYS$OUTPUT "Making DEMO3 ..."
$ SET DEFAULT [.DEMO.DEMO3]
$ 'COMPILER'  demo3.c
$ LINK/EXEC=demo3.exe 'OBJECTS1'+[]demo3.obj
$ RENAME demo3.exe [-.bin]
$ DELETE demo3.obj;*
$!
$ WRITE SYS$OUTPUT "Making DEMO4 ..."
$ SET DEFAULT [-.DEMO4]
$ 'COMPILER'  demo4.c
$ LINK/EXEC=demo4.exe 'OBJECTSv'+[]demo4.obj
$ RENAME demo4.exe [-.bin]
$ DELETE demo4.obj;*
$!
$ WRITE SYS$OUTPUT "Making DEMO2 - various versions ..."
$ SET DEFAULT [-.DEMO2]
$ 'COMPILER'  demo2a.c
$ LINK/EXEC=demo2a.exe 'OBJECTS1'+[]demo2a.obj
$ LINK/EXEC=demo2av.exe 'OBJECTSv'+[]demo2a.obj
$ 'COMPILER'  demo2b.c
$ LINK/EXEC=demo2b.exe 'OBJECTS1'+[]demo2b.obj
$ RENAME *.exe [-.bin]
$ DELETE *.obj;*
$!
$ WRITE SYS$OUTPUT "Making DEMO1 - two versions ..."
$ SET DEFAULT [-.DEMO1]
$ 'COMPILER'  demo1.c
$ LINK/EXEC=demo1.exe 'OBJECTSv'+[]demo1.obj
$ SET DEFAULT [-.-]
$ 'COMPILER' /DEFINE=("PDMtrace=1") transien.c,InOut.c
$ SET DEFAULT [.DEMO.DEMO1]
$ LINK/EXEC=demo1PDMtr.exe 'OBJECTSv'+[]demo1.obj
$ SET DEFAULT [-.-]
$ RENAME *.exe [-.bin]
$ DELETE demo1.obj;*
$!
$ WRITE SYS$OUTPUT "Making command definitions for the created images ..."
$ SET DEFAULT [-.bin]
DEMO1 == "$" + F$PARSE("demo1.exe")
DEMO1PDMTR == "$" + F$PARSE("demo1PDMtr.exe")
DEMO2A == "$" + F$PARSE("demo2a.exe")
DEMO2AV == "$" + F$PARSE("demo2av.exe")
DEMO2B == "$" + F$PARSE("demo2b.exe")
DEMO3 == "$" + F$PARSE("demo3.exe")
DEMO4 == "$" + F$PARSE("demo4.exe")
$!
$ DEFDEMO_NAME = F$PARSE("DEFDEMO.COM",,,,"SYNTAX_ONLY")
$ WRITE SYS$OUTPUT "Creating file "+DEFDEMO_NAME+" ..."
$ OPEN/WRITE o_f DEFDEMO.COM
$ WRITE o_f "$! DCL procedure to define DCL (foreign) commands to be able to invoke"
$ WRITE o_f "$! TRANSIENT demonstration images with the command line options,"
$ WRITE o_f "$! e.g., demo1 -h ;  demo1 -p ;  demo1 outfileRoot infile ;  etc."
$ WRITE o_f "$!"
$ WRITE o_f "$ DEMO1 == """+DEMO1+"""
$ WRITE o_f "$ DEMO1PDMTR == """+DEMO1PDMTR+"""
$ WRITE o_f "$ DEMO2A == """+DEMO2A+"""
$ WRITE o_f "$ DEMO2AV == """+DEMO2AV+"""
$ WRITE o_f "$ DEMO2B == """+DEMO2B+"""
$ WRITE o_f "$ DEMO3 == """+DEMO3+"""
$ WRITE o_f "$ DEMO4 == """+DEMO4+"""
$ CLOSE o_f
$!
$ WRITE SYS$OUTPUT ""
$ WRITE SYS$OUTPUT "   Contents of "+DEFDEMO_NAME+":"
$ WRITE SYS$OUTPUT ""
$ TYPE DEFDEMO.COM
$ TYPE SYS$INPUT

   All the above command definitions are now in force. Please, try!

   To be able to use them next time, either add to your LOGIN.COM file
   the following line:
$ WRITE SYS$OUTPUT "@"+DEFDEMO_NAME
$ WRITE SYS$OUTPUT "   or execute it each time after you log in."
$ PURGE
$ SET DEFAULT 'TDIR'
$ DELETE *.obj;*
$ EXIT
$ Clean:
$  CWD = F$DIRECTORY()
$  IF F$LOCATE(".DEMO.DEMO",CWD) .NE. F$LENGTH(CWD) THEN DELETE *.exe.*
$  PURGE
$  SET DEFAULT 'TDIR'
$  PURGE [.DEMO.BIN]
$  EXIT
