/* File demo/demo4/demo4.h; TRANSIENT V2.51; 14 Aug. 2001 */
/* (C) 2001 Miroslav Kolar */

IN_PAR(L,double,2.,%g,Model length)
CHECK_PAR(L>0.)

IN_PAR(interv,int,75,%d,No. of grid intervals in "[0,L]")
CHECK_PAR(interv>0)

IN_PAR(DX,double,0.01,%g,Activator diffusion constant)
CHECK_PAR(DX>=0.)

IN_PAR(DY,double,0.4,%g,Inhibitor  diffusion constant)
CHECK_PAR(DY>=0.)

IN_PAR(aa,double,0.05555555555555555,%g,Rate constant)
CHECK_PAR(aa>0.)

IN_PAR(bb,double,0.55555555555555555,%g,Rate constant)
CHECK_PAR(bb>=0.)

IN_PAR(cc,double,1.8,%g,Rate constant)
CHECK_PAR(cc>0.)

IN_PAR(dd,double,0.05555555555555555,%g,Rate constant)
CHECK_PAR(dd>=0.)

/* Initial state is a random perturbation with maximum amplitude
   randInitAmp  corresponding to a ramdom seed  randSeed  of either
   the trivial steady state or the zero morphogen concentrations state: */
IN_PAR(randInitAmpl,double,0.001,%g,Random max perturbation of initial state)
IN_PAR(randSeed,int,731,%d,Seed for random perturbation of initial state)
IN_PAR(Init,int,0,%d,0: Start near zero conc.; 1: near the trivial steady state)
CHECK_PAR(randSeed>0)
CHECK_PAR(randInitAmpl>0.)
CHECK_PAR(Init==0 || Init==1)

IN_STRPAR(BC,8,"massBal",Type of b.c. formulae: massBal or 3point)
/* "massBal" corresponds to the use of full mass-balance equation
	for the half intervals at model ends;
   "3point" to the standard three-point discretization formula.
Both for flux=0 von Neumann b.c.
*/
CHECK_PAR(!strcmp(BC,"massBal") || !strcmp(BC,"3point"))
