/* File nl3_ApBo.h; TRANSIENT V4.1; 19 Feb 2011 */
/* (C) 1999-2001,2011 Miroslav Kolar */

 case 0:  /* no lower and upper bounds */
   break;
 case 1:  /* no upper bound, constant lower bound */
   lowBnd = LB[EQNO][1];
   FORA
      if(c[i] < lowBnd) c[i] = lowBnd;
   break;
 case 16: /* no upper bound, set zero cutoff */
   lowBnd = LB[EQNO][1];
   FORA
      if(c[i] < lowBnd) c[i] = 0.;
   break;
 case 2:  /* no upper bound, piece-wise constant lower bound */
   lp = LB[EQNO] + 2;
   lowBnd = LB[EQNO][1];
   FORB {
      if(c[i] < lowBnd) c[i] = lowBnd;
      if(NoDe == (int)*lp) {
	      lp++;
	      lowBnd = *lp++;
      }
   }
   break;
 case 3:  /* no upper bound, distinct lower bound for each node */
   lp = LB[EQNO];
   FORA {
      lowBnd = *(++lp);
      if(c[i] < lowBnd) c[i] = lowBnd;
   }
   break;
 case 4:  /* constant upper bound, no lower bound */
   upBnd = UB[EQNO][1];
   FORA
      if(c[i] > upBnd) c[i] = upBnd;
   break;
 case 5:  /* constant upper and lower bounds */
   upBnd = UB[EQNO][1];
   lowBnd = LB[EQNO][1];
   FORA {
      if(c[i] < lowBnd) c[i] = lowBnd;
      else if(c[i] > upBnd) c[i] = upBnd;
   }
   break;
 case 17: /* constant upper bound, set zero cutoff */
   upBnd = UB[EQNO][1];
   lowBnd = LB[EQNO][1];
   FORA {
      if(c[i] < lowBnd) c[i] = 0.;
      else if(c[i] > upBnd) c[i] = upBnd;
   }
   break;
 case 6:  /* constant upper bound, piece-wise constant lower bound */
   upBnd = UB[EQNO][1];
   lp = LB[EQNO] + 2;
   lowBnd = LB[EQNO][1];
   FORB {
      if(c[i] < lowBnd) c[i] = lowBnd;
      else if(c[i] > upBnd) c[i] = upBnd;
      if(NoDe == (int)*lp) {
	      lp++;
	      lowBnd = *lp++;
      }
   }
   break;
 case 7:  /* constant upper bound, distinct lower bound for each node */
   upBnd = UB[EQNO][1];
   lp = LB[EQNO];
   FORA {
      ++lp;
      if(c[i] > upBnd) c[i] = upBnd;
      else {
	lowBnd = *lp;
	if(c[i] < lowBnd) c[i] = lowBnd;
      }
   }
   break;
 case 8:  /* piece-wise constant upper bound, no lower bound */
   up = UB[EQNO] + 2;
   upBnd = UB[EQNO][1];
   FORB {
      if(c[i] > upBnd) c[i] = upBnd;
      if(NoDe == (int)*up) {
	      up++;
	      upBnd = *up++;
      }
   }
   break;
 case 9:  /* piece-wise constant upper bound, constant lower bound */
   up = UB[EQNO] + 2;
   upBnd = UB[EQNO][1];
   lowBnd = LB[EQNO][1];
   FORB {
      if(c[i] < lowBnd) c[i] = lowBnd;
      else if(c[i] > upBnd) c[i] = upBnd;
      if(NoDe == (int)*up) {
	      up++;
	      upBnd = *up++;
      }
   }
   break;
 case 18: /* piece-wise constant upper bound, set zero cutoff */
   up = UB[EQNO] + 2;
   upBnd = UB[EQNO][1];
   lowBnd = LB[EQNO][1];
   FORB {
      if(c[i] < lowBnd) c[i] = 0.;
      else if(c[i] > upBnd) c[i] = upBnd;
      if(NoDe == (int)*up) {
	      up++;
	      upBnd = *up++;
      }
   }
   break;
 case 10: /* piece-wise constant upper bound and lower bound */
   up = UB[EQNO] + 2;
   upBnd = UB[EQNO][1];
   lp = LB[EQNO] + 2;
   lowBnd = LB[EQNO][1];
   FORB {
      if(c[i] < lowBnd) c[i] = lowBnd;
      else if(c[i] > upBnd) c[i] = upBnd;
      if(NoDe == (int)*up) {
	      up++;
	      upBnd = *up++;
      }
      if(NoDe == (int)*lp) {
	      lp++;
	      lowBnd = *lp++;
      }
   }
   break;
 case 11: /* piece-wise constant upper bound, distinct lower bounds */
   up = UB[EQNO] + 2;
   upBnd = UB[EQNO][1];
   lp = LB[EQNO];
   FORB {
      ++lp;
      if(c[i] > upBnd) c[i] = upBnd;
      else {
	lowBnd = *lp;
	if(c[i] < lowBnd) c[i] = lowBnd;
      }
      if(NoDe == (int)*up) {
	      up++;
	      upBnd = *up++;
      }
   }
   break;
 case 12: /* distinct upper bound for each node, no lower bound */
   up = UB[EQNO];
   FORA {
      upBnd = *(++up);
      if(c[i] > upBnd) c[i] = upBnd;
   }
   break;
 case 13: /* distinct upper bound for each node, constant lower bound */
   up = UB[EQNO];
   lowBnd = LB[EQNO][1];
   FORA {
      ++up;
      if(c[i] < lowBnd) c[i] = lowBnd;
      else {
	upBnd = *up;
	if(c[i] > upBnd) c[i] = upBnd;
      }
   }
   break;
 case 19: /* individiual upper bounds, set zero cutoff */
   up = UB[EQNO];
   lowBnd = LB[EQNO][1];
   FORA {
      ++up;
      if(c[i] < lowBnd) c[i] = 0.;
      else {
	upBnd = *up;
	if(c[i] > upBnd) c[i] = upBnd;
      }
   }
   break;
 case 14: /* distinct upper bound, piece-wise constant lower bound */
   up = UB[EQNO];
   lp = LB[EQNO] + 2;
   lowBnd = LB[EQNO][1];
   FORB {
      ++up;
      if(c[i] < lowBnd) c[i] = lowBnd;
      else {
	upBnd = *up;
	if(c[i] > upBnd) c[i] = upBnd;
      }
      if(NoDe == (int)*lp) {
	      lp++;
	      lowBnd = *lp++;
      }
   }
   break;
 case 15: /* distinct upper and lower bounds for each node */
   up = UB[EQNO];
   lp = LB[EQNO];
   FORA {
      upBnd = *(++up);
      ++lp;
      if(c[i] > upBnd) c[i] = upBnd;
      else {
	lowBnd = *lp;
	if(c[i] < lowBnd) c[i] = lowBnd;
      }
   }
   break;
}
}
