/* File nl3_Decl.h; TRANSIENT V4.3; 22 July 2018
 * (C) 2005-2011,2016,2018 Miroslav Kolar
 * Common declarations to nl3bandv.c and nl3band1.c: */


#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "dynarr.h"
#include "defs.h"


extern char
	msg[];
extern const int
	msgLength;
extern void
	exitTR(int,char*), // from InOut.c
	// from PDM:
	evalf(int), initNL3BANDV(double***LBp, double***UBp,
			double*F, double*A, double *B, double *D);
extern int
	monitor2, transCalc, NRiter,
	repeatPrevious, previousNRiter;
extern double
	TOL, TOLC;

// used in transien.c:
double fresidM, cresidM, fresidT, cresidT;

static double
	*c,
	**LB = NULL, **UB = NULL,
	cMax, FMax, tcMax, tFMax,
	cTmax, FTmax, tcTmax, tFTmax,
	*E, *xi,
	CresidPREC, FresidPREC,
	converged = -9.;
static int
	nodefresidM, nodecresidM,
	nodecMax, nodeFMax,
#if NodeNumberChangeENABL
	NNODEmax= 0,
#endif
	NNODE, NNODE1;

#define PE (void)fprintf(stderr,
#define PRl (void)snprintf(msg,msgLength,

#if NodeNumberChangeENABL
#define EXITTRm7 exitTR(-7,"The requested new # of nodes exceeds the current maximum.\nCall startband to redefine it");
#define EXITTRm7A exitTR(-7,"The requested new # of nodes must be positive");
#endif

#ifndef RAND_MAX
#define RAND_MAX 32767
#define RAND_WARNING { PE"\nRAND_MAX not predefined: TRANSIENT assumes\n\
that rand generates random numbers between 0 and 32767.\n");\
 PE"To switch off this message, redefine macro RAND_WARNING\n(and\
 check the definition of RAND_MAX) in "__FILE__".\n"); }
#else
#define RAND_WARNING
#endif

extern FILE *par_out;

void nl3bandCompiled(char CmntC)
/*============================*/
{
(void)fprintf(par_out,
	"%c nl3band%c.c with: TRUE_FABS=%d, NO_X=%d, NO_Y=%d, NR_BOUNDS=%d\n",
	CmntC, _NL3_PARENT_, TRUE_FABS, NO_X, NO_Y, NR_BOUNDS);
}

void reportDEBUG(void)
/*==================*/
{
#ifdef DEBUG
PE"DEBUG is on in nl3band%c.c; thus in each NR iteration of each time step\n\
at first a lot of debug output will be printed for each node.\n\
		Then the usual output (with one more added line after the last NR iteration):\n",  _NL3_PARENT_);
#endif
}
#undef _NL3_PARENT_
