/* File nl3_Rand.h; TRANSIENT V4.1; 19 Feb 2011 */
/* (C) 1999-2001,2011 Miroslav Kolar */

  case 0:  /* no lower and upper bounds */
   RaU = 2 *  Amp / RAND_MAX;
   FORA
	c[i] = c_o[i] + RaU * (rand()-0.5*RAND_MAX);
   break;
  case 1:  /* no upper bound, constant lower bound */
   lowBnd = LB[EQNO][1];
   goto c1_16;
  case 16: /* no upper bound, set zero cutoff */
   lowBnd = 0.;
 c1_16:
   FORA {
      RaU = c_o[i] + Amp;
      RaL = c_o[i] - Amp;
      if(RaL < lowBnd) RaL = lowBnd;
      c[i] = RaL + ((RaU - RaL) * rand()) / RAND_MAX;
   }
   break;
  case 2:  /* no upper bound, piece-wise constant lower bound */
   lp = LB[EQNO] + 2;
   lowBnd = LB[EQNO][1];
   FORB {
      RaU = c_o[i] + Amp;
      RaL = c_o[i] - Amp;
      if(RaL < lowBnd) RaL = lowBnd;
      c[i] = RaL + ((RaU - RaL) * rand()) / RAND_MAX;
      if(NoDe == (int)*lp) {
	      lp++;
	      lowBnd = *lp++;
      }
   }
   break;
  case 3:  /* no upper bound, distinct lower bound for each node */
   lp = LB[EQNO];
   FORA {
      lowBnd = *(++lp);
      RaU = c_o[i] + Amp;
      RaL = c_o[i] - Amp;
      if(RaL < lowBnd) RaL = lowBnd;
      c[i] = RaL + ((RaU - RaL) * rand()) / RAND_MAX;
   }
   break;
  case 4:  /* constant upper bound, no lower bound */
   upBnd = UB[EQNO][1];
   FORA {
      RaU = c_o[i] + Amp;
      RaL = c_o[i] - Amp;
      if(RaU > upBnd) RaU = upBnd;
      c[i] = RaL + ((RaU - RaL) * rand()) / RAND_MAX;
   }
   break;
  case 5:  /* constant upper and lower bounds */
   lowBnd = LB[EQNO][1];
   goto c5_17;
  case 17: /* constant upper bound, set zero cutoff */
   lowBnd = 0.;
 c5_17:
   upBnd = UB[EQNO][1];
   FORA {
      RaU = c_o[i] + Amp;
      RaL = c_o[i] - Amp;
      if(RaL < lowBnd) RaL = lowBnd;
      if(RaU > upBnd) RaU = upBnd;
      c[i] = RaL + ((RaU - RaL) * rand()) / RAND_MAX;
   }
   break;
  case 6:  /* constant upper bound, piece-wise constant lower bound */
   upBnd = UB[EQNO][1];
   lp = LB[EQNO] + 2;
   lowBnd = LB[EQNO][1];
   FORB {
      RaU = c_o[i] + Amp;
      RaL = c_o[i] - Amp;
      if(RaL < lowBnd) RaL = lowBnd;
      if(RaU > upBnd) RaU = upBnd;
      c[i] = RaL + ((RaU - RaL) * rand()) / RAND_MAX;
      if(NoDe == (int)*lp) {
	      lp++;
	      lowBnd = *lp++;
      }
   }
   break;
  case 7:  /* constant upper bound, distinct lower bound for each node */
   upBnd = UB[EQNO][1];
   lp = LB[EQNO];
   FORA {
      lowBnd = *(++lp);
      RaU = c_o[i] + Amp;
      RaL = c_o[i] - Amp;
      if(RaL < lowBnd) RaL = lowBnd;
      if(RaU > upBnd) RaU = upBnd;
      c[i] = RaL + ((RaU - RaL) * rand()) / RAND_MAX;
   }
   break;
  case 8:  /* piece-wise constant upper bound, no lower bound */
   up = UB[EQNO] + 2;
   upBnd = UB[EQNO][1];
   FORB {
      RaU = c_o[i] + Amp;
      RaL = c_o[i] - Amp;
      if(RaU > upBnd) RaU = upBnd;
      c[i] = RaL + ((RaU - RaL) * rand()) / RAND_MAX;
      if(NoDe == (int)*up) {
	      up++;
	      upBnd = *up++;
      }
   }
   break;
  case 9:  /* piece-wise constant upper bound, constant lower bound */
   lowBnd = LB[EQNO][1];
   goto c9_18;
  case 18: /* piece-wise constant upper bound, set zero cutoff */
   lowBnd = 0.;
 c9_18:
   up = UB[EQNO] + 2;
   upBnd = UB[EQNO][1];
   FORB {
      RaU = c_o[i] + Amp;
      RaL = c_o[i] - Amp;
      if(RaL < lowBnd) RaL = lowBnd;
      if(RaU > upBnd) RaU = upBnd;
      c[i] = RaL + ((RaU - RaL) * rand()) / RAND_MAX;
      if(NoDe == (int)*up) {
	      up++;
	      upBnd = *up++;
      }
   }
   break;
  case 10: /* piece-wise constant upper and lower bounds */
   up = UB[EQNO] + 2;
   upBnd = UB[EQNO][1];
   lp = LB[EQNO] + 2;
   lowBnd = LB[EQNO][1];
   FORB {
      RaU = c_o[i] + Amp;
      RaL = c_o[i] - Amp;
      if(RaL < lowBnd) RaL = lowBnd;
      if(RaU > upBnd) RaU = upBnd;
      c[i] = RaL + ((RaU - RaL) * rand()) / RAND_MAX;
      if(NoDe == (int)*up) {
	      up++;
	      upBnd = *up++;
      }
      if(NoDe == (int)*lp) {
	      lp++;
	      lowBnd = *lp++;
      }
   }
   break;
  case 11: /* piece-wise constant upper bound, distinct lower bounds */
   up = UB[EQNO] + 2;
   upBnd = UB[EQNO][1];
   lp = LB[EQNO];
   FORB {
      lowBnd = *(++lp);
      RaU = c_o[i] + Amp;
      RaL = c_o[i] - Amp;
      if(RaL < lowBnd) RaL = lowBnd;
      if(RaU > upBnd) RaU = upBnd;
      c[i] = RaL + ((RaU - RaL) * rand()) / RAND_MAX;
      if(NoDe == (int)*up) {
	      up++;
	      upBnd = *up++;
      }
   }
   break;
  case 12: /* distinct upper bound for each node, no lower bound */
   up = UB[EQNO];
   FORA {
      upBnd = *(++up);
      RaU = c_o[i] + Amp;
      RaL = c_o[i] - Amp;
      if(RaU > upBnd) RaU = upBnd;
      c[i] = RaL + ((RaU - RaL) * rand()) / RAND_MAX;
   }
   break;
  case 13: /* distinct upper bound for each node, constant lower bound */
   lowBnd = LB[EQNO][1];
   goto c13_19;
  case 19: /* individiual upper bounds, set zero cutoff */
   lowBnd = 0.;
 c13_19:
   up = UB[EQNO];
   FORA {
      upBnd = *(++up);
      RaU = c_o[i] + Amp;
      RaL = c_o[i] - Amp;
      if(RaL < lowBnd) RaL = lowBnd;
      if(RaU > upBnd) RaU = upBnd;
      c[i] = RaL + ((RaU - RaL) * rand()) / RAND_MAX;
   }
   break;
  case 14: /* distinct upper bound, piece-wise constant lower bound */
   up = UB[EQNO];
   lp = LB[EQNO] + 2;
   lowBnd = LB[EQNO][1];
   FORB {
      upBnd = *(++up);
      RaU = c_o[i] + Amp;
      RaL = c_o[i] - Amp;
      if(RaL < lowBnd) RaL = lowBnd;
      if(RaU > upBnd) RaU = upBnd;
      c[i] = RaL + ((RaU - RaL) * rand()) / RAND_MAX;
      if(NoDe == (int)*lp) {
	      lp++;
	      lowBnd = *lp++;
      }
   }
   break;
  case 15: /* distinct upper and lower bounds for each node */
   up = UB[EQNO];
   lp = LB[EQNO];
   FORA {
      upBnd = *(++up);
      lowBnd = *(++lp);
      RaU = c_o[i] + Amp;
      RaL = c_o[i] - Amp;
      if(RaL < lowBnd) RaL = lowBnd;
      if(RaU > upBnd) RaU = upBnd;
      c[i] = RaL + ((RaU - RaL) * rand()) / RAND_MAX;
   }
   break;
 }
}
