/* File nl3_strt.h; TRANSIENT V4.3; 29 Nov 2015 */
/* (C) 1999-2002,2011,2015 Miroslav Kolar */

 case 5:  /* constant upper and lower bounds */
   if(UB[EQNO][1] < LB[EQNO][1]) INCONSIST
   break;
 case 17: /* constant upper bound, set zero cutoff */
   if(UB[EQNO][1] < 0.) INCONSIST
   break;
 case 6:  /* constant upper bound, piece-wise constant lower bound */
   upBnd = UB[EQNO][1];
   lp = LB[EQNO] + 1;
   for(i = -1; ; lp++) {
      if(upBnd < *lp++) INCONSIST
      j = (int)*lp;
      if(j <= i || j > NNODE-2) break;
      i = j;
   }
   break;
 case 7:  /* constant upper bound, distinct lower bound for each node */
   upBnd = UB[EQNO][1];
   lp = LB[EQNO];
   for(i = 0; i < NNODE; i++) if(upBnd < *(++lp)) INCONSIST
   break;
 case 9:  /* piece-wise constant upper bound, constant lower bound */
   lowBnd = LB[EQNO][1];
   goto c9_18;
 case 18: /* piece-wise constant upper bound, set zero cutoff */
   lowBnd = 0.;
c9_18:
   up = UB[EQNO] + 1;
   for(i = -1; ; up++) {
      if(*up++ < lowBnd) INCONSIST
      j = (int)*up;
      if(j <= i || j > NNODE-2) break;
      i = j;
   }
   break;
 case 10: /* piece-wise constant upper and lower bounds */
   up = UB[EQNO] + 2;
   upBnd = UB[EQNO][1];
   lp = LB[EQNO] + 2;
   lowBnd = LB[EQNO][1];
   for(i = 0; i < NNODE; i++) {
      if(upBnd < lowBnd) INCONSIST
      if(i == (int)*up) {
	      up++;
	      upBnd = *up++;
      }
      if(i == (int)*lp) {
	      lp++;
	      lowBnd = *lp++;
      }
   }
   break;
 case 11: /* piece-wise constant upper bound, distinct lower bounds */
   up = UB[EQNO] + 2;
   upBnd = UB[EQNO][1];
   lp = LB[EQNO];
   for(i = 0; i < NNODE; i++) {
      if(upBnd < *(++lp)) INCONSIST
      if(i == (int)*up) {
	      up++;
	      upBnd = *up++;
      }
   }
   break;
 case 13: /* distinct upper bound for each node, constant lower bound */
   lowBnd = LB[EQNO][1];
   goto c13_19;
 case 19: /* individiual upper bounds, set zero cutoff */
   lowBnd = 0.;
c13_19:
   up = UB[EQNO];
   for(i = 0; i < NNODE; i++) if(*(++up) < lowBnd) INCONSIST
   break;
 case 14:      /* distinct upper bound, piece-wise constant lower bound */
   up = UB[EQNO];
   lp = LB[EQNO] + 2;
   lowBnd = LB[EQNO][1];
   for(i = 0; i < NNODE; i++) {
      if(*(++up) < lowBnd) INCONSIST
      if(i == (int)*lp) {
	      lp++;
	      lowBnd = *lp++;
      }
   }
   break;
 case 15: /* distinct upper and lower bounds for each node */
   up = UB[EQNO];
   lp = LB[EQNO];
   for(i = 0; i < NNODE; i++) if(*(++up) < *(++lp)) INCONSIST
   break;
